<?php
namespace Controllers;
// Контроллер Смены
class Changes extends Controller {

	public function __construct() {
		parent::__construct();
		$this->model=new \Models\Changes($this->db, $this->f3); // модель пользовательских групп
	}

	// Открываем смену
	function open() {
		$res=$this->model->get_change();
		if($res) {
			$res=array(
				'success'=>true,
				'reload'=>'.reports',
				'close_all_window'=>true,
				'txt'=>$this->messages->message('change_is_open')['txt']
			);
		}
		else {
			$res=array(
				'success'=>false,
				'txt'=>$this->messages->message('change_not_open')['txt']
			);
		}

		echo json_encode($res);
		exit();
	}

	// Открытие смены на ФР
	function open_fr() {
		$res=$this->model->open_fr();
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Открытие смены на Кассе
	function open_db() {
		$res=$this->model->open_db();
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Закрытие смены на ФР
	function close_fr() {
		$res=$this->model->close_fr();
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Закрытие смены на Кассе
	function close_db() {
		$res=$this->model->z(false);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Поиск смен
	function search() {
		$page=$this->f3->get('GET.page');
		if(!$page)$page=1;
		$dates=$this->f3->get('GET.dates');
		if($dates) {
			$dates=str_replace(' ', '', $dates);
			$dates=explode('-', $dates);
			$dates[0]=strtotime($dates[0]);
			$dates[1]=strtotime($dates[1])+24*3600;
		}
		$limit=$this->f3->get('lines_of_page');
		$changes=$this->model->search($dates, ($page-1)*$limit, $limit);
		if(count($changes)>0) {
			$this->f3->set('changes', $changes['changes']);
			$this->f3->set('pagination', $this->pagination($changes['count'], $page));
			$this->f3->set('page_data', $this->model->page_data('search'));
		}
		else {
			$this->f3->set('page_data', $this->messages->message('not_found'));
		}
	}

	// Закрываем смену
	function z() {
		//$api=new \Controllers\Api;
		//$api->tickets(false);
		$res=$this->model->z();
		$res['reload']='.reports';
		$res['close_all_window']=true;
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// X-отчет
	function x() {
		$res=$this->model->x();
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}
}
