// Сброс формы поиска товаров
function reset_product_search_form() {
	$('form[name="product_search_form"]').trigger("reset");
	$('form[name="product_search_form"] input[name="product_search"]').focus();
}

$('body').off('submit', 'form[name="product_search_form"]');
$('body').on('submit', 'form[name="product_search_form"]', function(){
	$('form[name="product_search_form"] input[type="text"]').val('');
	$('form[name="product_search_form"] input[type="text"]').blur();
});

$('body').off('click', '.line');
$('body').on('click', '.line', function(){
	$('input[type="radio"]', this).prop('checked', true);
	var line_id=$('input[type="radio"]', this).val();
	$('.line_control').each(function(){
		var href=$(this).attr('href');
		if(href) {
			href=href.substr(0, href.indexOf('=')+1)+line_id;
			$(this).attr('href', href);
		}
	});
	$('.line').removeClass('select_line');
	$(this).addClass('select_line');
});


// изменение количества товара
function change_count() {
	var radio=$('.line input[type="radio"]:checked');
	var line_id=radio.val();
	var count=Number(radio.attr('count'));
	load_ajax('/receipts/change_line?line_id='+line_id+'&count='+count);
	reset_product_search_form();
}

// Кнопка плюс (устанавливает введенное кол-во)
var timerId;
$('body').off('click', '.virtual_key_plus');
$('body').on('click', '.virtual_key_plus', function(){
	if($('input[name="product_search"]').val()!='' && $('input[name="product_search"]').val()!=0) {
		var count=$('input[name="coeff"]').val();
		if(!count) count=1;
		load_ajax('/receipts/add_line?product_id='+(-$.now())+'&count='+count+'&price='+$('input[name="product_search"]').val());
		reset_product_search_form();
		return;
	}
	var radio=$('.line input[type="radio"]:checked');
	if(radio.length>0) {
		var c=$('input[name="coeff"]').val().replace(',','.');
		if(c>0) {
			var count=c;
		}
		else {
			var count=radio.attr('count');
			//if(Math.floor(count)<count)return;
			count=Number(count)+1;
		}
		radio.attr('count', count);
		clearTimeout(timerId);
		timerId=setTimeout('change_count()', 500);
	}
});

// Кнопка минус (уменьшает на 1 штуку)
$('body').off('click', '.virtual_key_minus');
$('body').on('click', '.virtual_key_minus', function(){
	var radio=$('.line input[type="radio"]:checked');
	if(radio.length>0) {
		var count=radio.attr('count');
		//if(Math.floor(count)<count)return;
		count=Number(count)-1;
		if(count<=0)return;
		radio.attr('count', count);
		clearTimeout(timerId);
		timerId=setTimeout('change_count()', 500);
	}
});

// Управление фокусом
$('body').off('focus', 'form[name="product_search_form"] input[name="product_search"]');
$('body').on('focus', 'form[name="product_search_form"] input[name="product_search"]', function(){
	$('form[name="product_search_form"] .virtual_keyboard:not(.virtual_keyboard_hide) .virtual_key').attr('for', 'product_search');
	$('form[name="product_search_form"] .virtual_keyboard:not(.virtual_keyboard_hide) .virtual_key_bks').attr('for', 'product_search');
});

$('body').off('focus', 'form[name="product_search_form"] input[name="coeff"]');
$('body').on('focus', 'form[name="product_search_form"] input[name="coeff"]', function(){
	$('form[name="product_search_form"] .virtual_keyboard:not(.virtual_keyboard_hide) .virtual_key').attr('for', 'coeff');
	$('form[name="product_search_form"] .virtual_keyboard:not(.virtual_keyboard_hide) .virtual_key_bks').attr('for', 'coeff');
});

$('body').off('focus', 'form[name="receipts_search_form"] input[name="id"]');
$('body').on('focus', 'form[name="receipts_search_form"] input[name="id"]', function(){
	$('form[name="receipts_search_form"] .virtual_key').attr('for', 'receipt_id');
	$('form[name="receipts_search_form"] .virtual_key_bks').attr('for', 'receipt_id');
});

$('body').off('focus', 'form[name="receipts_search_form"] input[name="barcode"]');
$('body').on('focus', 'form[name="receipts_search_form"] input[name="barcode"]', function(){
	$('form[name="receipts_search_form"] .virtual_key').attr('for', 'barcode');
	$('form[name="receipts_search_form"] .virtual_key_bks').attr('for', 'barcode');
});

$('body').off('focus', 'form[name="receipts_search_form"] input[name="changes"]');
$('body').on('focus', 'form[name="receipts_search_form"] input[name="changes"]', function(){
	$('form[name="receipts_search_form"] .virtual_key').attr('for', 'changes_id');
	$('form[name="receipts_search_form"] .virtual_key_bks').attr('for', 'changes_id');
});

$('body').off('click', 'form[name="product_search_form"] .virtual_key_delete');
$('body').on('click', 'form[name="product_search_form"] .virtual_key_delete', function(){
	reset_product_search_form();
});

$('body').on('click', '.close', function(){
	reset_product_search_form();
});

$('body').off('click', '.tabs .tab');
$('body').on('click', '.tabs .tab', function(){
	$('.tabs .tab').removeClass('tab_select');
	$('.tab_page_select').removeClass('tab_page_select');
	$(this).addClass('tab_select');
	var p=$(this).attr('for');
	$(p).addClass('tab_page_select');
	var cash=$(this).attr('cash');
	var el=$('input[type="text"]', p).eq(0);
	if(cash==1) {
		el.focus();
		el.select();
	}
	else {
		$('#pay_change').hide();
	}
	pay_change(el);
});

$('body').off('focus', '.mixed_pay');
$('body').on('focus', '.mixed_pay', function(){
	var form=$(this).closest('form');
	var attr=form.find('.virtual_keyboard input[type="button"]').attr('for');
	if(attr!='mixed_pay_'+$(this).attr('pid')) {
		$(this).select();
	}
	form.find('.virtual_keyboard input[type="button"]').attr('for', 'mixed_pay_'+$(this).attr('pid'));
	form.find('.virtual_keyboard button').attr('for', 'mixed_pay_'+$(this).attr('pid'));
});

// считам сдачу
function pay_change(el) {
	var form=$(el).closest('form');
	var sum=0;
	var mix=0;
	$(form).find('input.client_sum').each(function(){
		sum+=Number($(this).val());
		if($(this).hasClass('mixed_pay')) {
			mix=1;
		}
	});
	sum=Math.round(sum*100)/100;
	var r=sum-receipt_sum;
	if($('input[name="type"]', form).val()==1) {
		$.ajax({
        	url: '/receipts/pay?sum='+receipt_sum+'&pay='+sum,
        	timeout: 3000
 		});
 	}
	$('#mixed_pay_add').hide();
	if(r>=0 && mix==0) {
		if(r>0) {
			$('#pay_change').show();
			$('#pay_change big').html(r.toFixed(2));
		}
		else {
			$('#pay_change').hide();
		}
		$('input[type="submit"]', form).attr('disabled', false);
	}
	else {
		$('#pay_change').hide();
		$('input[type="submit"]', form).attr('disabled', true);
		if(mix==1) {
			$('#mixed_pay_add big').html((-r).toFixed(2));
			$('#mixed_pay_add').show();
			if(r==0) {
				$('input[type="submit"]', form).attr('disabled', false);
			}
		}
	}
}

$('body').off('click', '#mixed_pay_add');
$('body').on('click', '#mixed_pay_add', function(){
	var input;
	var val=$('big', this).html();
	$('.mixed_pay').each(function(){
		if(!$(this).val() && input==undefined) {
			input=$(this);
		}
	});
	if(input) {
		input.val(val);
		pay_change(input);
	}
});

$('body').off('change', '.receipt_pay_form input[type="text"]');
$('body').on('change', '.receipt_pay_form input[type="text"]', function(e){
	var val=$(this).val();
	val=val.replace(/[^.0-9]/gim,'');
	$(this).val(val);
	pay_change(this);
});

$('body').off('keyup', '.receipt_pay_form input[type="text"]');
$('body').on('keyup', '.receipt_pay_form input[type="text"]', function(e){
	var val=$(this).val();
	val=val.replace(/[^.0-9]/gim,'');
	$(this).val(val);
	pay_change(this);
});

$('body').off('click', '.receipt_pay_form .virtual_keyboard input[type="button"]');
$('body').on('click', '.receipt_pay_form .virtual_keyboard input[type="button"]', function(){
	var el=$('.'+$(this).attr('for'));
	pay_change(el);
});

$('body').off('click', '.receipt_pay_form .virtual_keyboard button');
$('body').on('click', '.receipt_pay_form .virtual_keyboard button', function(){
	var el=$('.'+$(this).attr('for'));
	pay_change(el);
});

// Считаем сумму возврта
var sum_return=0;
function return_sum() {
	var count=0;
	var sum=0;
	$('.line_return').each(function(){
		count+=Number($('.count', this).val());
		sum+=Number($('.vprice', this).val()*$('.count', this).val());
	});
	$('#return_count').html(count.toFixed(3));
	$('.return_sum').html(sum.toFixed(2));
	sum_return=Math.round(sum*100)/100;
	if($('.mixed_pay').length==1) {
		$('.mixed_pay').val(sum.toFixed(2));
	}
}

// Возврат
function return_line(el, count) {
	var line_id=el.val();
	
	var tr='<td><span class="small">'+$('#line_'+line_id+' .product_title').html()+'</span>';
	tr+='<input type="hidden" name="receiptlines['+line_id+'][id]" value="'+el.attr('product_id')+'">';
	tr+='<input type="hidden" name="receiptlines['+line_id+'][short_title]" value="'+$('#line_'+line_id+' .product_title').html()+'">';
	tr+='<input type="hidden" name="receiptlines['+line_id+'][price]" value="'+el.attr('price')+'">';
	tr+='<input type="hidden" name="receiptlines['+line_id+'][vat]" value="'+el.attr('vat')+'">';
	tr+='<input type="hidden" name="receiptlines['+line_id+'][vat_type]" value="'+el.attr('vat_type')+'">';
	tr+='<input type="hidden" class="count" name="receiptlines['+line_id+'][count]" value="'+count+'">';
	tr+='<input type="hidden" class="count" name="receiptlines['+line_id+'][discount]" value="'+el.attr('discount')+'">';
	tr+='<input type="hidden" class="vprice" value="'+el.attr('vprice')+'">';
	tr+='</td>';
	tr+='<td width="100" align="center">'+el.attr('vprice')+'</td>';
	tr+='<td width="100" align="center">'+count.toFixed(3)+'</td>';
	tr+='<td width="100" align="center">'+(el.attr('vprice')*count).toFixed(2)+'</td>';
	tr+='<td width="50" align="center"><button class="line_control remove_return" for="#line_return_'+line_id+'"><i class="fas fa-times"></i></button></td>';
	if($('#line_return_'+line_id).length>0) {
		$('#line_return_'+line_id).html(tr);
	}
	else {
		$('#return_add').before('<tr class="line_return" id="line_return_'+line_id+'">'+tr+'</tr>');
	}

	return_sum();
}

$('body').off('focus', '.return_count_input');
$('body').on('focus', '.return_count_input', function(){
	$('.virtual_keyboard_return_count_input').show();
});

$('body').off('focus', '.discount_input');
$('body').on('focus', '.discount_input', function(){
	if(!$('.virtual_keyboard_discount_input').is(":visible")) {
		$(this).select();
	}
	$('.virtual_keyboard_discount_input').show();
});

$('body').off('focus', '.client_0');
$('body').on('focus', '.client_0', function(){
	$('.virtual_keyboard_client_0').show();
});

if($('.virtual_keyboard_hide').length>0) {
	$(document).mouseup(function(e) {
		var div=$('.virtual_keyboard_hide');
		if(!div.is(e.target) && div.has(e.target).length===0 && !$('.return_count_input').is(e.target) && !$('.client_0').is(e.target) && !$('.discount_input').is(e.target)) {
			div.hide();
		}
	});
}

$('body').off('click', '.virtual_keyboard_hide .virtual_key_ok');
$('body').on('click', '.virtual_keyboard_hide .virtual_key_ok', function() {
	$('.virtual_keyboard_hide').hide();
});

$('body').off('click', '.return_ok');
$('body').on('click', '.return_ok', function(){
	var radio=$('.line input[type="radio"]:checked');
	var count=Number($('.return_count_input').val());
	$('.return_count_input').val('');
	if(count>0) {
		if(count>Number(radio.attr('count'))) {
			show_window('error', '<p class="false">Нет такого количества</p>');
			return;
		}

		return_line(radio, count);
	}
});

$('body').off('click', 'input[name="return_1"]');
$('body').on('click', 'input[name="return_1"]', function() {
	var radio=$('.line input[type="radio"]:checked');
	var count=1;
	var line_id=radio.val();
	if($('#line_return_'+line_id).length>0) {
		count=Number($('#line_return_'+line_id+' .count').val())+Number(count);
	}

	if(count>Number(radio.attr('count'))) {
		show_window('error', '<p class="false">Нет такого количества</p>');
		return;
	}

	return_line(radio, count);
});

$('body').off('click', 'input[name="return_str"]');
$('body').on('click', 'input[name="return_str"]', function() {
	var radio=$('.line input[type="radio"]:checked');
	return_line(radio, Number(radio.attr('count')));
});

$('body').off('click', 'input[name="return_all"]');
$('body').on('click', 'input[name="return_all"]', function() {
	$('.line').each(function(){
		var radio=$('input[type="radio"]', this);
		return_line(radio, Number(radio.attr('count')));
	});
});

// Удаляем строку возврата
$('body').off('click', '.remove_return');
$('body').on('click', '.remove_return', function(){
	var el=$(this).attr('for');
	$(el).remove();
	return_sum();
});

$('body').off('click', 'input[name="save_return"]');
$('body').on('click', 'input[name="save_return"]', function(){
	return_change();
	$('#return_paymentmethods').show();
	if($('.mixed_pay').length>1) {
		$('.mixed_pay').eq(0).focus();
	}
});

$('body').off('click', '#return_paymentmethods .close_button');
$('body').on('click', '#return_paymentmethods .close_button', function(){
	$('#return_paymentmethods').hide();
});

// Считаем введеную сумму возврата
function return_change() {
	var sum=0
	var ok=true;
	$('.mixed_pay').each(function(){
		var val=Number($(this).val());
		var max=Number($(this).attr('max'));
		var pid=$(this).attr('pid');
		if(val>max) {
			$('.error_'+pid).addClass('false');
			ok=false;
		}
		else {
			$('.error_'+pid).removeClass('false');
		}
		sum+=Number(val);
		sum=Math.round(sum*100)/100;
		$('#return_add_pay').html((sum_return-sum).toFixed(2));
	});
	if(ok) {
		if(sum==sum_return && sum_return>0) {
			$('input[type="submit"]').attr('disabled', false);
		}
		else {
			$('input[type="submit"]').attr('disabled', true);
		}
	}
}

$('body').off('change', '#return_paymentmethods input[type="text"]');
$('body').on('change', '#return_paymentmethods input[type="text"]', function(e){
	var val=$(this).val();
	val=val.replace(/[^.0-9]/gim,'');
	$(this).val(val);
	return_change();
});

$('body').off('keyup', '#return_paymentmethods input[type="text"]');
$('body').on('keyup', '#return_paymentmethods input[type="text"]', function(e){
	var val=$(this).val();
	val=val.replace(/[^.0-9]/gim,'');
	$(this).val(val);
	return_change();
});

$('body').off('click', '#return_paymentmethods .virtual_keyboard input[type="button"]');
$('body').on('click', '#return_paymentmethods .virtual_keyboard input[type="button"]', function(){
	return_change();
});

$('body').off('click', '#return_paymentmethods .virtual_keyboard button');
$('body').on('click', '#return_paymentmethods .virtual_keyboard button', function(){
	return_change();
});

$('body').off('submit', 'form[name="receipts_return_form"]');
$('body').on('submit', 'form[name="receipts_return_form"]', function(){
	$('#return_paymentmethods').hide();
	$('.line_return').remove();
	$('.mixed_pay').val('');
	return_sum();
});

// возвращает cookie с именем name, если есть, если нет, то undefined
function getCookie(name) {
	var matches = document.cookie.match(new RegExp(
		"(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
	));
	return matches ? decodeURIComponent(matches[1]) : undefined;
}

// Скидка
$('body').off('change', 'input[name="discount"]');
$('body').on('change', 'input[name="discount"]', function(){
	var discount=$(this).val();
	if(discount<0 || discount>100) {
		show_window('error', '<p class="false">Скидка должна быть в промежутке от 0 до 100</p>');
		discount=getCookie('discount');
		$(this).val(discount);
	}
	document.cookie = "discount="+discount+";";
	discount/=100;
	var sum=0;
	$('.line_sum').each(function(){
		sum+=Number($(this).html());
	});
	sum-=sum*discount;
	sum=Math.round(sum*100)/100;
	$('#receipt_sum').html(sum.toFixed(2));
});

$('body').off('change', 'input[name="discount_line"]');
$('body').on('change', 'input[name="discount_line"]', function(){
	var d=$(this).val();
	if(d<0 || d>100) {
		show_window('error', '<p class="false">Скидка должна быть в промежутке от 0 до 100</p>');
		$('form[name="receipts_change_price_form"] input[type="submit"]').attr("disabled", true);
		return;
	}
	else {
		$('form[name="receipts_change_price_form"] input[type="submit"]').attr("disabled", false);
	}
	var price=$('input[name="price0"]').val();
	price-=price*d/100;
	$('input[name="price"]').val(price.toFixed(2));
});


// Показываем остатки
$('body').off('click', '.show_currentstock');
$('body').on('click', '.show_currentstock', function(){
	var radio=$('.line input[type="radio"]:checked');
	if(radio.length<=0)return;
	var stock=radio.attr('currentstock');
	var title=$('.select_line .product_title').html();
	show_window('stock', '<h1>Остатки на складе</h1><p>'+title+' - <big>'+stock+'</big></p>');
});

$('body').off('change', '.client_0');
$('body').on('change', '.client_0', function(){
	$('.client').val($(this).val());
});


$('body').off('click', '.virtual_keyboard input');
$('body').on('click', '.virtual_keyboard input', function(){
	$('.'+$(this).attr('for')).trigger("change");
});

$('body').off('click', '.virtual_keyboard button');
$('body').on('click', '.virtual_keyboard button', function(){
	$('.'+$(this).attr('for')).trigger("change");
});

if($('form[name="product_search_form"] input[name="product_search"]').length>0) {
	var input_s=$('form[name="product_search_form"] input[name="product_search"]');
	var input_c=$('form[name="product_search_form"] input[name="coeff"]');
	$('body').keypress(function(e){
		if(!input_s.is(':focus') && !input_c.is(':focus') && $('.popup').length==0) {
			input_s.focus();
		}
	});
}

// Показ клавиатуры для поиска товаров
$('.virtual_key_key').click(function(){
	$('.virtual_keyboard_product_search').show();
});

$('.virtual_key_eng').click(function(){
	$('.virtual_keyboard .ru').hide();
	$('.virtual_keyboard .eng').show();
});

$('.virtual_key_ru').click(function(){
	$('.virtual_keyboard .ru').show();
	$('.virtual_keyboard .eng').hide();
});

$('body').off('focus', 'form[name="receipts_change_price_form"] input[type="text"]');
$('body').on('focus', 'form[name="receipts_change_price_form"] input[type="text"]', function(){
	var c=$(this).attr('class');
	var f=$('form[name="receipts_change_price_form"] .virtual_keyboard input[type="button"]').attr('for');
	if(c!=f) {
		$(this).select();
	}
	$('form[name="receipts_change_price_form"] .virtual_keyboard input[type="button"]').attr('for', c);
	$('form[name="receipts_change_price_form"] .virtual_keyboard button').attr('for', c);
});


$('body').off('click', 'input[name="sales_receipts_0"]');
$('body').on('click', 'input[name="sales_receipts_0"]', function(){
	if($(this).prop("checked")) {
		$('.sales_receipts').val(1);
	}
	else {
		$('.sales_receipts').val(0);
	}
});
